compracompa/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('accounts.urls')),
    path('', include('core.urls'))

]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
else:
    urlpatterns += staticfiles_urlpatterns()

core/urls.py
from django.urls import path
from core.views import HomeView, StoreCreateView, StoreUpdateView, StoreDetailView, StoreDeleteView

urlpatterns = [
    path('', HomeView.as_view(), name='home'),
    path('comercio/crear', StoreCreateView.as_view(), name='crear_comercio'),
    path('comercio/modificar/<int:pk>', StoreUpdateView.as_view(), name='modificar_comercio'),
    path('comercio/borrar/<int:pk>', StoreDeleteView.as_view(), name='borrar_comercio'),
    path('comercio/<int:pk>', StoreDetailView.as_view(), name='detalle_comercio'),
]

accounts/models.py
from django.contrib.auth.models import AbstractUser
from django.utils.translation import gettext_lazy as _
from django.db import models


#choice availables

PROVINCIAS = (
    ('C', 'Ciudad Autónoma de Buenos Aires'),
    ('B', 'Buenos Aires'),
    ('K', 'Catamarca'),
    ('H', 'Chaco'),
    ('U', 'Chubut'),
    ('X', 'Córdoba'),
    ('W', 'Corrientes'),  
    ('E', 'Entre Ríos'),
    ('P', 'Formosa'),
    ('Y', 'Jujuy'),
    ('L', 'La Pampa'),
    ('F', 'La Rioja'),
    ('M', 'Mendoza'),
    ('N', 'Misiones'),
    ('Q', 'Neuquén'),
    ('R', 'Río Negro'),
    ('A', 'Salta'),
    ('J', 'San Juan'),
    ('D', 'San Luis'),
    ('Z', 'Santa Cruz'),
    ('S', 'Santa Fe'),
    ('G', 'Santiago del Estero'),
    ('V', 'Tierra del Fuego'),
    ('T', 'Tucumán'),
)

GENEROS = [
    ("M", "Masculino"),
    ("F", "Femenino"),
    ("O", "Otro"),
    ("N", "Prefiero no decir"),
    ("MTF", "Mujer Transgénero"),
    ("FTM", "Hombre Transgénero"),
    ("NB", "No Binario"),
    ("GF", "Género Fluida"),
    ("AG", "Agénero"),
    ("BD", "Bigénero"),
    ("DE", "Demigénero"),
    ("QT", "Queer"),
    ("IT", "Intersex"),
]

class CustomUser(AbstractUser):

    """
    Usuario Personalizado
    """
    
    # foto_perfil = models.ImageField(_("Foto de Perfil"), upload_to='profile_img/', blank=True, null=True)
    dni = models.PositiveIntegerField(_("DNI"), null=True)
    fecha_nacimiento = models.DateField(_("Fecha de Nacimiento"), auto_now=False, auto_now_add=False, blank=True, null=True)
    genero = models.CharField(_("Género"), max_length=10, choices=GENEROS, null=True)
    telefono = models.PositiveIntegerField(_("Telefono"), blank=True, null=True)
    direccion = models.CharField(_("Dirección"), max_length=255, blank=True, null=True)
    ciudad = models.CharField(_("Ciudad"), max_length=50, blank=True, null=True)
    provincia = models.CharField(_("Provincia"), max_length=50, choices=PROVINCIAS, default="V")
    moderador = models.BooleanField(_("Moderador"), default=False)

    # @property
    # def edad(self):
    #     if self.fecha_nacimiento:
    #         today = date.today()
    #         edad = today.year - self.fecha_nacimiento.year - ((today.month, today.day) < (self.fecha_nacimiento.month, self.fecha_nacimiento.day))
    #         return edad
    #     return None

core/models.py
from django.db import models
from django.utils.translation import gettext_lazy as _

TIPO_BENEFICIO = [
    ('descuentos', 'Descuentos'),
    ('promocion', 'Promoción'),
    ('envio_gratis', 'Envío Gratis'),
    ('compra_x_obsequio', 'Compra X y lleva un obsequio'),
    ('rebajas_temporada', 'Rebajas de Temporada'),
    ('cliente_frecuente', 'Programa de Cliente Frecuente'),
    ('cupones_descuento', 'Cupones de Descuento'),
    ('oferta_flash', 'Ofertas Flash'),
    ('combo_oferta', 'Combos en Oferta'),
    ('tarjeta_fidelidad', 'Tarjeta de Fidelidad'),
    ('regalos_compras_altas', 'Regalos con Compras Altas'),
    ('descuento_cumpleaños', 'Descuento en Cumpleaños'),
    ('programa_referidos', 'Programa de Referidos'),
    ('eventos_especiales', 'Descuentos en Eventos Especiales'),
    ('descuento_redes_sociales', 'Descuento por Seguir en Redes Sociales'),
    ('descuento_primer_compra', 'Descuento en la Primera Compra'),
]

PUNTUACION_COMENTARIO = [
    ('1','1'),
    ('2','2'),
    ('3','3'),
    ('4','4'),
    ('5','5'),
]

class Rubro(models.Model):

    name = models.CharField(_("Nombre"), max_length=50)
    

    class Meta:
        verbose_name = _("rubro")
        verbose_name_plural = _("rubros")

    def __str__(self):
        return self.name

    # def get_absolute_url(self):
    #     return reverse("rubro_detail", kwargs={"pk": self.pk})

class Comercio(models.Model):

    user = models.ForeignKey("accounts.CustomUser", verbose_name=_("Usuario"), on_delete=models.CASCADE, related_name="Comercio")
    activo = models.BooleanField(_("Activo"), default=False)
    name = models.CharField(_("Nombre de Comercio"), max_length=50)
    descripcion = models.TextField(_("Descripción"), max_length=200)
    imagen = models.ImageField(_("Imagen"), upload_to="media/", height_field=None, width_field=None, max_length=None)
    rubros = models.ManyToManyField(Rubro, verbose_name=_("Rubro"), related_name="Rubros")
    facebook = models.URLField(_("Facebook"), max_length=200, blank=True, null=True)
    instagram = models.URLField(_("Facebook"), max_length=200, blank=True, null=True)
    website = models.URLField(_("Website"), max_length=200, blank=True, null=True)
    telefono = models.CharField(_("Teléfono"), max_length=50, blank=True, null=True)

    class Meta:
        verbose_name = _("comercio")
        verbose_name_plural = _("comercios")

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse("comercio_detail", kwargs={"pk": self.pk})

class Beneficio(models.Model):

    comercio = models.ForeignKey(Comercio, verbose_name=_("Comercio"), on_delete=models.CASCADE, related_name="Beneficio")
    tipo_beneficio = models.CharField(_("Tipo de Beneficio"), choices=TIPO_BENEFICIO, max_length=50)
    descripcion = models.CharField(_("Descripción"), max_length=100)

    class Meta:
        verbose_name = _("beneficio")
        verbose_name_plural = _("beneficios")

    def __str__(self):
        return self.descripcion

    # def get_absolute_url(self):
    #     return reverse("beneficio_detail", kwargs={"pk": self.pk})

## Comentarios

class Comentario(models.Model):
    timestamp = models.DateTimeField(auto_now_add=True, blank=True)
    texto = models.CharField(_("Comentario"), max_length=200)
    puntuacion = models.CharField(_("Puntuación"), choices=PUNTUACION_COMENTARIO, max_length=100)
    usuario = models.ForeignKey("accounts.CustomUser", verbose_name=_("Usuario"), on_delete=models.CASCADE, related_name="Comentarios")
    comercio = models.ForeignKey(Comercio, verbose_name=_("Comercio"), on_delete=models.CASCADE, related_name="Comentario")

    class Meta:
        verbose_name = _("comentario")
        verbose_name_plural = _("comentarios")

    def __str__(self):
        return self.texto

    # def get_absolute_url(self):
    #     return reverse("comentario_detail", kwargs={"pk": self.pk})

core/views.py
from django.shortcuts import render
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy, path
from django.contrib import messages
from django.views.generic import CreateView, DetailView, UpdateView, DeleteView, ListView
from .models import Comercio

class HomeView(ListView): 
    model = Comercio
    template_name = 'home.html'

    def get_queryset(self):
        return Comercio.objects.filter(activo=True)
    
class StoreCreateView(LoginRequiredMixin, CreateView):
    model = Comercio
    template_name = 'create_comercio.html'
    fields = '__all__'
    success_url = reverse_lazy('home')

class StoreUpdateView(LoginRequiredMixin, UpdateView):
    model = Comercio
    template_name = 'update_comercio.html'
    fields = '__all__'
    success_url = reverse_lazy('home')

class StoreDeleteView(LoginRequiredMixin, DeleteView):
    model = Comercio
    template_name = 'delete_comercio.html'
    success_url = reverse_lazy('home')

class StoreDetailView(DetailView):
    model = Comercio
    template_name = 'detail_comercio.html'

core/templates/home.html
{% extends "core/base.html" %}
{% block content %}
    <main>
        <section class="py-5 text-center container">
            <div class="row py-lg-5">
                <div class="col-lg-6 col-md-8 mx-auto">
                    <h1 class="fw-light">¿Qué hacemos?</h1>
                    <p class="lead text-muted">
                        Acá vas a encontrar todo lo que necesitás: desde el kiosco de la esquina hasta la parrillita del barrio, todo bien peronista, ¿entendés? Una joyita para los compañeros y compañeras que quieran apoyar al laburante local. ¡No te lo pierdas!
                    </p>
                    <p>
                        <a href="#" class="btn btn-primary my-2">Main call to action</a>
                        <a href="#" class="btn btn-secondary my-2">Secondary action</a>
                    </p>
                </div>
            </div>
        </section>
        {% for comercio in object_list %}
            <div class="album py-5 bg-light">
                <div class="container">
                    <div class="row row-cols-1 row-cols-sm-2 row-cols-md-3 g-3">
                        <div class="col">
                            <div class="card shadow-sm">
                                <img src="{{comercio.imagen.url}}"
                                     alt="Imagen del comercio">
                                <div class="card-body">
                                    <h4>{{ comercio.name }}</h4>
                                <p class="card-text">{{ user.ciudad }} , {{user.get_provincia_display}} </p>

                                    <p class="card-text">{{ comercio.descripcion }}</p>
                                    <div class="d-flex justify-content-between align-items-center">
                                        <div class="btn-group">
                                            <button type="button" class="btn btn-sm btn-outline-secondary">Detalles</button>
                                            {% comment %} <button type="button" class="btn btn-sm btn-outline-secondary">Edit</button> {% endcomment %}
                                        </div>
                                        <small class="text-muted">9 mins</small>
                                    </div>
                                    {% for rubro in comercio.rubros.all %}<span class="badge bg-secondary">{{ rubro.name }}</span>{% endfor %}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        {% endfor %}
</main>
{% endblock content %}